import { O as OptionalHasher } from '../shared/gpds.6f120ef4.mjs';
import './BidirectionalMap.mjs';

var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var _storage, _emptySet, _hasher, _a;
class MultiMap {
  constructor(iterable, options = {}) {
    __privateAdd(this, _storage, /* @__PURE__ */ new Map());
    __privateAdd(this, _emptySet, /* @__PURE__ */ new Set());
    __privateAdd(this, _hasher, void 0);
    __publicField(this, _a, "MultiMap");
    __privateSet(this, _hasher, new OptionalHasher(options.hashKey ?? null));
    if (iterable) {
      for (const [key, value] of iterable) {
        this.set(key, value);
      }
    }
  }
  get size() {
    return __privateGet(this, _storage).size;
  }
  clear() {
    __privateGet(this, _hasher).clear();
    __privateGet(this, _storage).clear();
  }
  delete(key, value) {
    const mapped = __privateGet(this, _hasher).hash(key);
    let existed = false;
    if (value !== void 0) {
      const storage = __privateGet(this, _storage).get(mapped);
      if (storage) {
        existed = storage.delete(value);
      }
    } else {
      existed = __privateGet(this, _storage).delete(mapped);
    }
    return existed;
  }
  get(key) {
    return __privateGet(this, _storage).get(__privateGet(this, _hasher).hash(key)) ?? __privateGet(this, _emptySet);
  }
  has(key) {
    return __privateGet(this, _storage).has(__privateGet(this, _hasher).hash(key));
  }
  set(key, value) {
    const mapped = __privateGet(this, _hasher).hash(key);
    let storage = __privateGet(this, _storage).get(mapped);
    if (!storage) {
      storage = /* @__PURE__ */ new Set();
      __privateGet(this, _storage).set(mapped, storage);
    }
    storage.add(value);
    return this;
  }
  *entries() {
    for (const [key, values] of __privateGet(this, _storage).entries()) {
      yield [__privateGet(this, _hasher).unhash(key), values];
    }
  }
  *keys() {
    for (const key of __privateGet(this, _storage).keys()) {
      yield __privateGet(this, _hasher).unhash(key);
    }
  }
  values() {
    return __privateGet(this, _storage).values();
  }
}
_a = Symbol.toStringTag;
_storage = new WeakMap();
_emptySet = new WeakMap();
_hasher = new WeakMap();

export { MultiMap };
