import { BidirectionalMap } from '../maps/BidirectionalMap.mjs';

var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var _storageMap, _hasher, _storage, storage_get;
class OptionalHasher {
  constructor(mapper = null) {
    __privateAdd(this, _storage);
    __privateAdd(this, _storageMap, null);
    __privateAdd(this, _hasher, void 0);
    __privateSet(this, _hasher, mapper);
  }
  hash(input) {
    if (__privateGet(this, _hasher)) {
      let mapped = __privateGet(this, _storage, storage_get).getLeft(input);
      if (!mapped) {
        mapped = __privateGet(this, _hasher).call(this, input);
        __privateGet(this, _storage, storage_get).set(input, mapped);
      }
      return mapped;
    }
    return input;
  }
  unhash(output) {
    if (__privateGet(this, _hasher)) {
      return __privateGet(this, _storage, storage_get).getRight(output);
    }
    return output;
  }
  clear() {
    __privateGet(this, _storage, storage_get).clear();
  }
}
_storageMap = new WeakMap();
_hasher = new WeakMap();
_storage = new WeakSet();
storage_get = function() {
  if (!__privateGet(this, _storageMap)) {
    __privateSet(this, _storageMap, new BidirectionalMap());
  }
  return __privateGet(this, _storageMap);
};

export { OptionalHasher as O };
